setLogMode(1);


function oLoginEditMenu::populate(%this) {
    %this.add( "Retrieve Login Key", 0 );

	%count = 0;
	for(%file = findFirstFile("*.key"); %file !$= ""; %file = findNextFile("*.key"))
	{
 		%name = fileBase(%file);
 		%this.add( %name, %count++ );
	}
 
    if (%count < 1) %this.setActive(0);
	%id = %this.findText( $LastLoginKey );
	if ( %id == -1 )
		%id = 0;
	%text = %this.getTextById(%id);
	%this.setSelected( %id );
	%this.onSelect( %id, %text );
}

function oLoginEditMenu::onSelect( %this, %id, %text ) {
    if (%id == 0) {
       oLoginPasswordBox.setPosition(118, 129);
       passTxt.setPosition(37, 137);
       accnTxt.setPosition(37, 107);
       rmbrPass.setVisible(0);
       oLoginEditBox.setVisible(1);
    } else {
       oLoginPasswordBox.setPosition(118, 99);
       passTxt.setPosition(37, 107);
       accnTxt.setPosition(37, 77);
       rmbrPass.setVisible(1);
       oLoginEditBox.setVisible(0);

    }

    $LastLoginKey = %text;
	%this.setText( %text );
}
function oCreateAccountDlg::onWake( %this )
{
   %this.open = true;

   CreateAccountNextBtn.setActive( false );
   updateNextButton(%this);
}
function oCreateAccountDlg::onSleep( %this )
{
   %this.open = false;
}
function oCreateAccountDlg::nextBtn(%this,%reverse) {
    %this.showFields = false;
    if(%reverse) %this.page--;
    else %this.page++;
    
    switch (%this.page) {
       case 1:
          oTitleBar.setText("Create Account - Step 1 of 3");
          CreateAccountPrevBtn.setValue(" CANCEL");
          CreateAccountNextBtn.setValue("NEXT STEP");
          %keyText = $keyCreated ? "KEYPAIR GENERATED" : "GENERATE YOUR KEYPAIR";
          %hintText = $keyCreated ? "Click the NEXT STEP button to proceed." : "Click the above button to proceed.";
          CreateAccountGenBtn.setValue(%keyText);
          CreateAccountGenBtn.setActive(!$keyCreated);
          CreateAccountNextBtn.setActive($keyCreated);
          HintText2.setText(%hintText);
          %headtext = "Step One: Generate Your Keypair";
          %body = "  In order to create your account, you must first generate your unique public and private account keys locally.  These will enable you to play on online servers without the need to connect to a login server, and will provide high security so your account can't be stolen.  \n\n  The final step of the process requires the keys to be signed by the account creation server, so if it's marked as offline you should try again later.";
          AccountInstructions.setText(%headtext);
          AccountText.setText(%body);
          CreateAccountGenBtn.setVisible(1);
          HintText.setVisible(1);
          HintText.setPosition(100, 255);
          HintText.setText("");
          checkAuthOnline();//insert availability check
          
       case 2:
          %this.showFields = true;
          oTitleBar.setText("Create Account - Step 2 of 3");
          %headtext = "Step Two: Choose Your Account Information";
          %body = "  Pick the login information you'd like below:";
          AccountInstructions.setText(%headtext);
          AccountText.setText(%body);
          HintText.setVisible(0);
          CreateAccountGenBtn.setVisible(0);
          CreateAccountNextBtn.setActive(0);
          CreateAccountPrevBtn.setValue("BACK");
          CreateAccountNextBtn.setValue("NEXT STEP");
          HintText.setVisible(1);
          HintText.setPosition(100, 245);
          HintText.setText("");
          HintText2.setText("Fill out the above form to proceed.");
          //schedule field checker

       case 3:
          oTitleBar.setText("Create Account - Step 3 of 3");
          %headtext = "Step Three: Verify Your Details";
          %body = "  Please confirm the details below are correct before you go on, as there are pastries about.  Also, remember to write down your account information so you don't lose it.";
          AccountInstructions.setText(%headtext);
          AccountText.setText(%body);
          HintText.setVisible(1);
          HintText.setPosition(100, 165);
          HintText.setConfText();
          //CreateAccountNextBtn.setActive(0);
          CreateAccountNextBtn.setValue("FINISH");
          CreateAccountGenBtn.setVisible(0);
          HintText2.setText("Click the FINISH button to register and login.");

          
       case 4:
          //finished, create account.
          //Registration info to pass through:
          //  $CreateAccountLoginName
          //  $CreateAccountPassword

          Canvas.popDialog( oCreateAccountDlg );
          LoginMessagePopup( "PLEASE WAIT", "Contacting server..." );
          schedule(1000, 0, LoginDone);
          
       default:
          Canvas.popDialog( oCreateAccountDlg );
          Canvas.pushDialog( OnlineDlg );
          
    }
    CN_userName.setVisible(%this.showFields);
    CA_userName.setVisible(%this.showFields);
    CN_chooPass.setVisible(%this.showFields);
    CA_chooPass.setVisible(%this.showFields);
    CN_confPass.setVisible(%this.showFields);
    CA_confPass.setVisible(%this.showFields);


}
function CA_userName::validateWarriorName( %this )
{
   %name = %this.getValue();
   %test = strToPlayerName( %name );
   if ( %name !$= %test )
      %this.setText( %test );
}

function checkAuthOnline() {
   %online = getRandom(1);
   if (%online) {
      HintText.setText("The account creation server is <color:00FF00>ONLINE<color:42e5f4> and connectable.");
      CreateAccountGenBtn.setActive(!$keyCreated);
   } else {
      HintText.setText("The account creation server is <color:FF0000>OFFLINE<color:42e5f4> and unconnectable.");
      CreateAccountGenBtn.setActive(0);
   }

}

function updateNextButton()
{
   if ( !oCreateAccountDlg.open )
      return;

   %allDone = true;
   switch (oCreateAccountDlg.page) {
      case 1:
        if (!$keyCreated) %allDone = false;

      case 2:
        if ( strlen( $CreateAccountLoginName ) < 3 ) {
           %allDone = false;
           if ( strlen( $CreateAccountLoginName ) > 0 ) HintText.setText("<color:FF0000>Error:<color:42e5f4> Your username must be at least 3 characters long.");
           else HintText.setText("");
        } else if ( strlen( $CreateAccountPassword ) < 6) {
           %allDone = false;
           if ( strlen( $CreateAccountPassword ) > 0 ) HintText.setText("<color:FF0000>Error:<color:42e5f4> Your password must be at least 6 characters long.");
           else HintText.setText("");
        } else if ( strcmp( $CreateAccountPassword, $CreateAccountConfirmPassword ) ) {
           %allDone = false;
           if ( strlen( $CreateAccountConfirmPassword ) > 0 ) HintText.setText("<color:FF0000>Error:<color:42e5f4> Your password confirmation doesn't match.");
           else HintText.setText("");
        } else HintText.setText("");

   }
   CreateAccountNextBtn.setActive( %allDone );

   schedule( 1000, 0, updateNextButton );
}

function oCreateAccountDlg::genBtn(%this) {
    $keyCreated = true;
    CreateAccountGenBtn.setActive(!$keyCreated);
    CreateAccountGenBtn.setValue("KEYPAIR GENERATED");
    HintText2.setText("Click the NEXT STEP button to proceed.");
    CreateAccountNextBtn.setActive(1);
}
function HintText::onURL(%this, %url) {
  if (%url $= "pswd") {
     %this.hidePswd = !%this.hidePswd;
     %this.setConfText();
  }
}
function HintText::setConfText(%this) {
  if (%this.hidePswd $= "") %this.hidePswd = 1;
  if (%this.hidePswd)
    while (strlen(%pswd) < strlen($CreateAccountPassword)) %pswd = %pswd @ "*";
    
  else %pswd = $CreateAccountPassword;
  HintText.setText("<font:Univers Condensed Bold:22>Username: "@$CreateAccountLoginName@"\n<a:pswd>Password</a>: "@%pswd);
}
function newCreateAccount() {
    $CreateAccountLoginName = "";
    $CreateAccountPassword = "";
    $CreateAccountConfirmPassword = "";
    Canvas.pushDialog( oCreateAccountDlg );
    Canvas.popDialog( OnlineDlg );
    oCreateAccountDlg.page = 0;
    oCreateAccountDlg.nextBtn();
}
function newLoginProcess () {
    if (oLoginEditMenu.getSelected() == 0) {
       //Connect to auth, download key
       // vars: $oLoginName $oLoginPassword
    } else {
       %key = oLoginEditMenu.getSelected();
       %key = oLoginEditMenu.getTextById(%key);
       Canvas.popDialog( OnlineDlg );
       LoginMessagePopup( "PLEASE WAIT", "Logging in..." );
       if ( $pref::RememberPassword ) oLoginPasswordBox.savePassword();
       schedule(1000, 0, LoginDone);
    }

}
// Launch command, opens the online tabs, sans master/irc address references
function PlayOnline()
{
   $FirstLaunch = true;
   setNetPort(0);
   $PlayingOnline = true;
   Canvas.setContent(LaunchGui);
}
oLoginEditMenu.populate();
